### Method

# EDataServer OAuth2Services find

since: 3.28

#### Declaration [src]

    EOAuth2Service*
    e_oauth2_services_find (
      EOAuth2Services* services,
      ESource* source
    )

#### Description [src]

Searches the list of currently known OAuth2 services for the one which can be used with the given `source`.

The returned `EOAuth2Service` is referenced for thread safety, if found.

Available since: 3.28

#### Parameters

`source`

  Type: `ESource`

  An `ESource`.

  The data is owned by the caller of the method.

#### Return value

Type: `EOAuth2Service`

A referenced `EOAuth2Service`, which can be used with given `source`, or `NULL`, when none was found.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.